#version 430 core
layout (location = 0) out vec4 FragColor;
layout (location = 1) out vec4 BrightColor;  

in vec2 TexCoords;

uniform sampler2D texture_diffuse1;
uniform sampler2D texture_diffuse2;

uniform bool enabled;//if true -> light enabled

void main()
{    
    if (enabled) {
        FragColor = texture(texture_diffuse1, TexCoords);
    } else {
        FragColor = texture(texture_diffuse2, TexCoords) * 0.5;//make texture a bit darker
    }
    // check whether fragment output is higher than threshold, if so output as brightness color
    float brightness = dot(FragColor.rgb, vec3(0.2126, 0.7152, 0.0722));
    if(brightness > 0.5)
        BrightColor = vec4(FragColor.rgb, 1.0);
    else
        BrightColor = vec4(0.0, 0.0, 0.0, 1.0);
}