#version 430 core

layout (location = 0) in vec3 vertices;
layout (location = 1) in vec2 texCoords;
layout (location = 2) in vec4 position;
layout (location = 3) in vec3 color;

out vec3 particleColor;
out vec2 pos;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

void main() {
	vec3 camRight = vec3(view[0][0], view[1][0], view[2][0]);
	vec3 camUp = vec3(view[0][1], view[1][1], view[2][1]);
	vec3 vertexPos = position.xyz + camRight * vertices.x * position.w + camUp * vertices.y * position.w;
    gl_Position = projection * view * model * vec4(vertexPos, 1.0);
    particleColor = color;
	pos = texCoords;
}